1 # SPDX-License-Identifier: GPL-2.0+
5 MIRROR_DOCKER: docker.io
11 # Grab our configured image. The source for this is found
12 # in the u-boot tree at tools/docker/Dockerfile
13 image: ${MIRROR_DOCKER}/trini/u-boot-gitlab-ci-runner:jammy-20230804-25Aug2023
15 # We run some tests in different order, to catch some failures quicker.
21 .buildman_and_testpy_template: &buildman_and_testpy_dfn
23 retry: 2 # QEMU may be too slow, etc.
27 # Clone uboot-test-hooks
28 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
29 - git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
30 - ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
31 - ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
32 - grub-mkimage --prefix="" -o ~/grub_x86.efi -O i386-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
33 - grub-mkimage --prefix="" -o ~/grub_x64.efi -O x86_64-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
34 - if [[ "${TEST_PY_BD}" == "qemu-riscv32_spl" ]]; then
35 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.2/opensbi-1.2-rv-bin.tar.xz | tar -C /tmp -xJ;
36 export OPENSBI=/tmp/opensbi-1.2-rv-bin/share/opensbi/ilp32/generic/firmware/fw_dynamic.bin;
38 - if [[ "${TEST_PY_BD}" == "qemu-riscv64_spl" ]] || [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
39 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.2/opensbi-1.2-rv-bin.tar.xz | tar -C /tmp -xJ;
40 export OPENSBI=/tmp/opensbi-1.2-rv-bin/share/opensbi/lp64/generic/firmware/fw_dynamic.bin;
44 - cp -v /tmp/${TEST_PY_BD}/*.{html,css} .
45 - rm -rf /tmp/uboot-test-hooks /tmp/venv
47 # If we've been asked to use clang only do one configuration.
48 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD}
49 - echo BUILD_ENV ${BUILD_ENV}
50 - if [ -n "${BUILD_ENV}" ]; then
53 - tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e
54 --board ${TEST_PY_BD} ${OVERRIDE}
55 - cp ~/grub_x86.efi $UBOOT_TRAVIS_BUILD_DIR/
56 - cp ~/grub_x64.efi $UBOOT_TRAVIS_BUILD_DIR/
57 - cp /opt/grub/grubriscv64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_riscv64.efi
58 - cp /opt/grub/grubaa64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm64.efi
59 - cp /opt/grub/grubarm.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm.efi
60 # create sdcard / spi-nor images for sifive unleashed using genimage
61 - if [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
63 cp ${UBOOT_TRAVIS_BUILD_DIR}/spl/u-boot-spl.bin .;
64 cp ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.itb .;
66 genimage --inputpath . --config board/sifive/unleashed/genimage_sdcard.cfg;
67 cp images/sdcard.img ${UBOOT_TRAVIS_BUILD_DIR}/;
69 genimage --inputpath . --config board/sifive/unleashed/genimage_spi-nor.cfg;
70 cp images/spi-nor.img ${UBOOT_TRAVIS_BUILD_DIR}/;
72 - if [[ "${TEST_PY_BD}" == "coreboot" ]]; then
74 "https://drive.google.com/uc?id=1uJ2VkUQ8czWFZmhJQ90Tp8V_zrJ6BrBH&export=download" |
75 xz -dc >${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom;
77 "https://drive.google.com/uc?id=149Cz-5SZXHNKpi9xg6R_5XITWohu348y&export=download" >
80 ./cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom add-flat-binary -f ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.bin -n fallback/payload -c LZMA -l 0x1110000 -e 0x1110000;
82 - virtualenv -p /usr/bin/python3 /tmp/venv
83 - . /tmp/venv/bin/activate
84 - pip install -r test/py/requirements.txt
85 # "${var:+"-k $var"}" expands to "" if $var is empty, "-k $var" if not
86 - export PATH=/opt/qemu/bin:/tmp/uboot-test-hooks/bin:${PATH};
87 export PYTHONPATH=/tmp/uboot-test-hooks/py/travis-ci;
88 ./test/py/test.py -ra --bd ${TEST_PY_BD} ${TEST_PY_ID}
89 ${TEST_PY_TEST_SPEC:+"-k ${TEST_PY_TEST_SPEC}"}
90 --build-dir "$UBOOT_TRAVIS_BUILD_DIR"
103 build all 32bit ARM platforms:
104 extends: .world_build
107 git config --global --add safe.directory "${CI_PROJECT_DIR}";
108 pip install -r tools/buildman/requirements.txt;
109 ./tools/buildman/buildman -o /tmp -PEWM arm -x aarch64 || ret=$?;
110 if [[ $ret -ne 0 ]]; then
111 ./tools/buildman/buildman -o /tmp -seP;
115 build all 64bit ARM platforms:
116 extends: .world_build
118 - virtualenv -p /usr/bin/python3 /tmp/venv
119 - . /tmp/venv/bin/activate
121 git config --global --add safe.directory "${CI_PROJECT_DIR}";
122 pip install -r tools/buildman/requirements.txt;
123 ./tools/buildman/buildman -o /tmp -PEWM aarch64 || ret=$?;
124 if [[ $ret -ne 0 ]]; then
125 ./tools/buildman/buildman -o /tmp -seP;
129 build all PowerPC platforms:
130 extends: .world_build
133 git config --global --add safe.directory "${CI_PROJECT_DIR}";
134 ./tools/buildman/buildman -o /tmp -P -E -W powerpc || ret=$?;
135 if [[ $ret -ne 0 ]]; then
136 ./tools/buildman/buildman -o /tmp -seP;
140 build all other platforms:
141 extends: .world_build
144 git config --global --add safe.directory "${CI_PROJECT_DIR}";
145 ./tools/buildman/buildman -o /tmp -PEWM -x arm,powerpc || ret=$?;
146 if [[ $ret -ne 0 ]]; then
147 ./tools/buildman/buildman -o /tmp -seP;
156 check for new CONFIG symbols outside Kconfig:
159 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
160 # If grep succeeds and finds a match the test fails as we should
162 - git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
163 :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
164 :^include/linux/kconfig.h :^tools/ && exit 1 || exit 0
166 # build documentation
170 - virtualenv -p /usr/bin/python3 /tmp/venvhtml
171 - . /tmp/venvhtml/bin/activate
172 - pip install -r doc/sphinx/requirements.txt
173 - make htmldocs KDOC_WERROR=1
176 # ensure all configs have MAINTAINERS entries
177 Check for configs without MAINTAINERS entry:
180 - ./tools/buildman/buildman --maintainer-check || exit 0
182 # Ensure host tools build
183 Build tools-only and envtools:
186 - make tools-only_config tools-only -j$(nproc);
188 make tools-only_config envtools -j$(nproc)
190 Run binman, buildman, dtoc, Kconfig and patman testsuites:
193 - git config --global user.name "GitLab CI Runner";
195 git config --global --add safe.directory "${CI_PROJECT_DIR}";
197 virtualenv -p /usr/bin/python3 /tmp/venv;
198 . /tmp/venv/bin/activate;
199 pip install -r test/py/requirements.txt;
200 pip install -r tools/buildman/requirements.txt;
201 export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only;
202 export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt";
203 export PATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}";
205 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
208 ./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test;
209 ./tools/buildman/buildman -t;
210 ./tools/dtoc/dtoc -t;
211 ./tools/patman/patman test;
214 # Check for any pylint regressions
218 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
219 - pip install -r test/py/requirements.txt
220 - pip install -r tools/buildman/requirements.txt
221 - pip install asteval pylint==2.12.2 pyopenssl
222 - export PATH=${PATH}:~/.local/bin
223 - echo "[MASTER]" >> .pylintrc
224 - echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
225 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only
227 - ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
231 - export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt"
234 # Check for pre-schema driver model tags
235 Check for pre-schema tags:
238 - git config --global --add safe.directory "${CI_PROJECT_DIR}";
239 # If grep succeeds and finds a match the test fails as we should
241 - git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
243 # Check we can package the Python tools
244 Check packing of Python tools:
249 # Test sandbox with test.py
252 TEST_PY_BD: "sandbox"
253 <<: *buildman_and_testpy_dfn
255 sandbox with clang test.py:
257 TEST_PY_BD: "sandbox"
258 OVERRIDE: "-O clang-16"
259 <<: *buildman_and_testpy_dfn
261 sandbox without LTO test.py:
263 TEST_PY_BD: "sandbox"
264 BUILD_ENV: "NO_LTO=1"
265 <<: *buildman_and_testpy_dfn
269 TEST_PY_BD: "sandbox64"
270 <<: *buildman_and_testpy_dfn
272 sandbox64 with clang test.py:
274 TEST_PY_BD: "sandbox64"
275 OVERRIDE: "-O clang-16"
276 <<: *buildman_and_testpy_dfn
278 sandbox64 without LTO test.py:
280 TEST_PY_BD: "sandbox64"
281 BUILD_ENV: "NO_LTO=1"
282 <<: *buildman_and_testpy_dfn
286 TEST_PY_BD: "sandbox_spl"
287 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
288 <<: *buildman_and_testpy_dfn
290 sandbox_noinst_test.py:
292 TEST_PY_BD: "sandbox_noinst"
293 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
294 <<: *buildman_and_testpy_dfn
296 sandbox_noinst with LOAD_FIT_FULL test.py:
298 TEST_PY_BD: "sandbox_noinst"
299 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
300 OVERRIDE: "-a CONFIG_SPL_LOAD_FIT_FULL=y"
301 <<: *buildman_and_testpy_dfn
305 TEST_PY_BD: "sandbox_vpl"
306 TEST_PY_TEST_SPEC: "vpl or test_spl"
307 <<: *buildman_and_testpy_dfn
309 # Enable tracing and disable LTO, to ensure functions are not elided
310 sandbox trace_test.py:
312 TEST_PY_BD: "sandbox"
313 BUILD_ENV: "FTRACE=1 NO_LTO=1"
314 TEST_PY_TEST_SPEC: "trace"
315 OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000 -a CONFIG_TRACE_BUFFER_SIZE=0x02000000"
316 <<: *buildman_and_testpy_dfn
320 TEST_PY_BD: "evb-ast2500"
321 TEST_PY_ID: "--id qemu"
322 <<: *buildman_and_testpy_dfn
326 TEST_PY_BD: "evb-ast2600"
327 TEST_PY_ID: "--id qemu"
328 <<: *buildman_and_testpy_dfn
330 sandbox_flattree test.py:
332 TEST_PY_BD: "sandbox_flattree"
333 <<: *buildman_and_testpy_dfn
335 vexpress_ca9x4 test.py:
337 TEST_PY_BD: "vexpress_ca9x4"
338 TEST_PY_ID: "--id qemu"
339 <<: *buildman_and_testpy_dfn
341 integratorcp_cm926ejs test.py:
343 TEST_PY_BD: "integratorcp_cm926ejs"
344 TEST_PY_TEST_SPEC: "not sleep"
345 TEST_PY_ID: "--id qemu"
346 <<: *buildman_and_testpy_dfn
350 TEST_PY_BD: "qemu_arm"
351 TEST_PY_TEST_SPEC: "not sleep"
352 <<: *buildman_and_testpy_dfn
356 TEST_PY_BD: "qemu_arm64"
357 TEST_PY_TEST_SPEC: "not sleep"
358 <<: *buildman_and_testpy_dfn
362 TEST_PY_BD: "M5208EVBE"
363 TEST_PY_ID: "--id qemu"
364 TEST_PY_TEST_SPEC: "not sleep and not efi"
365 OVERRIDE: "-a CONFIG_M68K_QEMU=y -a ~CONFIG_MCFTMR"
366 <<: *buildman_and_testpy_dfn
371 TEST_PY_TEST_SPEC: "not sleep and not efi"
372 TEST_PY_ID: "--id qemu"
373 <<: *buildman_and_testpy_dfn
375 qemu_maltael test.py:
377 TEST_PY_BD: "maltael"
378 TEST_PY_TEST_SPEC: "not sleep and not efi"
379 TEST_PY_ID: "--id qemu"
380 <<: *buildman_and_testpy_dfn
382 qemu_malta64 test.py:
384 TEST_PY_BD: "malta64"
385 TEST_PY_TEST_SPEC: "not sleep and not efi"
386 TEST_PY_ID: "--id qemu"
387 <<: *buildman_and_testpy_dfn
389 qemu_malta64el test.py:
391 TEST_PY_BD: "malta64el"
392 TEST_PY_TEST_SPEC: "not sleep and not efi"
393 TEST_PY_ID: "--id qemu"
394 <<: *buildman_and_testpy_dfn
396 qemu-ppce500 test.py:
398 TEST_PY_BD: "qemu-ppce500"
399 TEST_PY_TEST_SPEC: "not sleep"
400 <<: *buildman_and_testpy_dfn
402 qemu-riscv32 test.py:
404 TEST_PY_BD: "qemu-riscv32"
405 TEST_PY_TEST_SPEC: "not sleep"
406 <<: *buildman_and_testpy_dfn
408 qemu-riscv64 test.py:
410 TEST_PY_BD: "qemu-riscv64"
411 TEST_PY_TEST_SPEC: "not sleep"
412 <<: *buildman_and_testpy_dfn
414 qemu-riscv32_spl test.py:
416 TEST_PY_BD: "qemu-riscv32_spl"
417 TEST_PY_TEST_SPEC: "not sleep"
418 <<: *buildman_and_testpy_dfn
420 qemu-riscv64_spl test.py:
422 TEST_PY_BD: "qemu-riscv64_spl"
423 TEST_PY_TEST_SPEC: "not sleep"
424 <<: *buildman_and_testpy_dfn
428 TEST_PY_BD: "qemu-x86"
429 TEST_PY_TEST_SPEC: "not sleep"
430 <<: *buildman_and_testpy_dfn
434 TEST_PY_BD: "qemu-x86_64"
435 TEST_PY_TEST_SPEC: "not sleep"
436 <<: *buildman_and_testpy_dfn
438 r2dplus_i82557c test.py:
440 TEST_PY_BD: "r2dplus"
441 TEST_PY_ID: "--id i82557c_qemu"
442 <<: *buildman_and_testpy_dfn
444 r2dplus_pcnet test.py:
446 TEST_PY_BD: "r2dplus"
447 TEST_PY_ID: "--id pcnet_qemu"
448 <<: *buildman_and_testpy_dfn
450 r2dplus_rtl8139 test.py:
452 TEST_PY_BD: "r2dplus"
453 TEST_PY_ID: "--id rtl8139_qemu"
454 <<: *buildman_and_testpy_dfn
456 r2dplus_tulip test.py:
458 TEST_PY_BD: "r2dplus"
459 TEST_PY_ID: "--id tulip_qemu"
460 <<: *buildman_and_testpy_dfn
462 sifive_unleashed_sdcard test.py:
464 TEST_PY_BD: "sifive_unleashed"
465 TEST_PY_ID: "--id sdcard_qemu"
466 <<: *buildman_and_testpy_dfn
468 sifive_unleashed_spi-nor test.py:
470 TEST_PY_BD: "sifive_unleashed"
471 TEST_PY_ID: "--id spi-nor_qemu"
472 <<: *buildman_and_testpy_dfn
474 xilinx_zynq_virt test.py:
476 TEST_PY_BD: "xilinx_zynq_virt"
477 TEST_PY_TEST_SPEC: "not sleep"
478 TEST_PY_ID: "--id qemu"
479 <<: *buildman_and_testpy_dfn
481 xilinx_versal_virt test.py:
483 TEST_PY_BD: "xilinx_versal_virt"
484 TEST_PY_TEST_SPEC: "not sleep"
485 TEST_PY_ID: "--id qemu"
486 <<: *buildman_and_testpy_dfn
491 TEST_PY_TEST_SPEC: "not sleep"
492 TEST_PY_ID: "--id qemu"
493 <<: *buildman_and_testpy_dfn
497 TEST_PY_BD: "coreboot"
498 TEST_PY_TEST_SPEC: "not sleep"
499 TEST_PY_ID: "--id qemu"
500 <<: *buildman_and_testpy_dfn